=== debian/changelog ===
libfido2 (1.4.0-2) unstable; urgency=medium

  [ nicoo ]
  * Amend changelog for v1.4.0-1
    Add missing change in debian/copyright, setting Upstream-Contact

  [ Andreas Hasenack ]
  * Run regression tests at build time

 -- Colin Watson <cjwatson@debian.org>  Wed, 27 May 2020 09:42:04 +0100

libfido2 (1.4.0-1) unstable; urgency=medium

  [ Colin Watson ]
  * New upstream release.
  * Pass -c4 to dpkg-gensymbols, so that we notice if
    debian/libfido2-1.symbols is out of date.

  [ nicoo ]
  * debian/copyright: Set Upstream-Contact to Yubico's OSS maintainers role

 -- Colin Watson <cjwatson@debian.org>  Sat, 18 Apr 2020 12:15:18 +0100
