=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 # license that can be found in the LICENSE file.
 
 list(APPEND COMPAT_SOURCES
+	../openbsd-compat/clock_gettime.c
 	../openbsd-compat/getopt_long.c
 	../openbsd-compat/strlcat.c
 	../openbsd-compat/strlcpy.c
@@ -14,6 +15,13 @@
 
 # drop -rdynamic
 set(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "")
+
+# enable -Wconversion -Wsign-conversion
+if(NOT MSVC)
+	set_source_files_properties(assert.c cred.c info.c manifest.c reset.c
+	    retries.c setpin.c util.c PROPERTIES COMPILE_FLAGS
+	    "-Wconversion -Wsign-conversion")
+endif()
 
 # manifest
 add_executable(manifest manifest.c ${COMPAT_SOURCES})
@@ -42,3 +50,11 @@
 # retries
 add_executable(retries retries.c ${COMPAT_SOURCES})
 target_link_libraries(retries fido2)
+
+# select
+add_executable(select select.c ${COMPAT_SOURCES})
+target_link_libraries(select fido2)
+if(MINGW)
+	# needed for nanosleep() in mingw
+	target_link_libraries(select winpthread)
+endif()
