=== debian/changelog ===
libfido2 (1.5.0-2~bpo10+1) buster-backports; urgency=medium

  * d/control: Downgrade versioned B-D cmake (3.14 -> 3.0, as
    requested in upstream's CMakeLists.txt).
  * Rebuild and upload to buster-backports.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 04 Nov 2020 14:08:26 +0100

libfido2 (1.5.0-2) unstable; urgency=medium

  * Cherry-pick upstream patch to fix 32-bit build errors.

 -- Colin Watson <cjwatson@debian.org>  Sun, 20 Sep 2020 23:12:57 +0100

libfido2 (1.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Colin Watson <cjwatson@debian.org>  Sun, 20 Sep 2020 17:49:14 +0100
